 <?php
/**
 * 缓存函数，以文件缓存形式保存，$date 为空，存入缓存，不为空，取出缓存
 * @param $key String 键值
 * @param $data String、Array 数据集
 * @return 存入缓存或者取出缓存
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-05-16
 */
 
require_once(globalStatic::$root_directory.'Register/CRMRedis.php');

function ClearAllOpacheFile()
{
  
    //opcache_reset(globalStatic::$root_directory.'tabdata.php');
    $global_crmredisobj=CRMRedis::getInstance();
    if($global_crmredisobj!='error')
    {
       
        if(function_exists('opcache_invalidate'))
        {
            opcache_invalidate(globalStatic::$root_directory.'tabdata.php',true);
            opcache_invalidate(globalStatic::$root_directory.'parent_tabdata.php',true);
            opcache_invalidate(globalStatic::$root_directory.'parent_language.php',true);
            opcache_invalidate(globalStatic::$root_directory.'tab_language.php',true);
            opcache_invalidate(globalStatic::$root_directory.'include/language/zh.php',true);
            opcache_invalidate(globalStatic::$root_directory.'include/language/en.php',true);
            
             
        }
    }
    else if(function_exists("opcache_reset"))
    {
        
        opcache_reset();
        opcache_invalidate(globalStatic::$root_directory.'tabdata.php',true);
        opcache_invalidate(globalStatic::$root_directory.'parent_tabdata.php',true);
        opcache_invalidate(globalStatic::$root_directory.'parent_language.php',true);
        opcache_invalidate(globalStatic::$root_directory.'tab_language.php',true);
        opcache_invalidate(globalStatic::$root_directory.'include/language/zh.php',true);
        opcache_invalidate(globalStatic::$root_directory.'include/language/en.php',true);
        
    }
    
}

function Cache($key,$data=array()) {
	$key_hash = md5('firstldcrm'.$key.'lastldcrm');
	$cachepath = globalStatic::$root_directory.'dataCache/Cache/';
    global $global_crmredisobj;
    $global_crmredisobj=CRMRedis::getInstance();
    
    if($global_crmredisobj!='error')
    {
       
        if(empty($data))
        {
         
            return $global_crmredisobj->getvalue($key);
        }
        else
        {
            
            $global_crmredisobj->setvalue($key,$data);
        }
        
        return ;
    }
     
	if(!empty($data)){//set
		$cache_filename = $cachepath . 'datacache_' . $key_hash . '.php';
		@file_put_contents($cache_filename, '<?php exit;?>' . time() . serialize($data));
        if(function_exists("opcache_reset"))
        {
             opcache_invalidate($cache_filename,true);
        }
		clearstatcache();
	}else{//get
		$return_data = false;
		$cache_filename = $cachepath . 'datacache_' . $key_hash . '.php';
		if(is_file($cache_filename) && ($data = file_get_contents($cache_filename)) && isset($data{23})){
			$filetime = substr($data,13,10);
			$data = substr($data, 23);
			$return_data = @unserialize($data);
		}
		return $return_data;
	}
}

/**
 * edit:can
 * reason:根据目录创建缓存
 * */

function CacheDirectory($key,$directory,$data='')
{
    global $global_crmredisobj;
    $global_crmredisobj=CRMRedis::getInstance();
    if($global_crmredisobj!='error')
    {
        if(empty($data))
        {


            return $global_crmredisobj->getvalue($key);
        }
        else
            $global_crmredisobj->setvalue($key,$data);
        
        return ;
    }
    
    $key_hash = md5('firstldcrm'.$key.'lastldcrm');
	$cachepath = globalStatic::$root_directory."dataCache/$directory/";
    if(!is_dir($cachepath)) {
        mkdir($cachepath, 0777, true);
    }
	if(!empty($data)){//set
		$cache_filename = $cachepath . 'datacache_' . $key_hash . '.php';
		@file_put_contents($cache_filename, '<?php exit;?>' . time() . serialize($data));
        if(function_exists("opcache_reset"))
        {
             opcache_invalidate($cache_filename,true);
        }
		clearstatcache();
	}else{//get
		$return_data = false;
		$cache_filename = $cachepath . 'datacache_' . $key_hash . '.php';
		if(is_file($cache_filename) && ($data = file_get_contents($cache_filename)) && isset($data{23})){
			$filetime = substr($data,13,10);
			$data = substr($data, 23);
			$return_data = @unserialize($data);
		}
		return $return_data;
	}
}
/**
 * request 默认过滤函数，过滤输入
 * @param $key String request键值
 * @return Request 过滤后的值
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-05-16
 */
function Input($key){
	if(isset($_REQUEST[$key])){
		$_REQUEST[$key] = htmlspecialchars($_REQUEST[$key]);
		$_REQUEST[$key] = strip_tags($_REQUEST[$key]);
		return trim($_REQUEST[$key]);
	}
	return '';
}
/**
 * 持久缓存，缓存文件不会批量清空
 * 但可以精确删除某一个持久缓存
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-28
 */
function MemoryCache($key,$data='') {
	$key_hash = md5('memoryfirstldcrm'.$key.'memorylastldcrm');
	$cachepath = globalStatic::$root_directory.'dataCache/Memory/';
	if(!empty($data)){//set
		$cache_filename = $cachepath . 'memorycache_' . $key_hash . '.php';
        
		@file_put_contents($cache_filename, '<?php exit;?>' . time() . serialize($data));
		clearstatcache();
	}else{//get
		$return_data = false;
		$cache_filename = $cachepath . 'memorycache_' . $key_hash . '.php';
		if(is_file($cache_filename) && ($data = file_get_contents($cache_filename)) && isset($data{23})){
			$filetime = substr($data,13,10);
			$data = substr($data, 23);
			$return_data = @unserialize($data);
		}
		return $return_data;
	}
}
/**
 * 删除数据缓存
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-28
 */
function clearCacheFiles(){
    ClearAllOpacheFile();//清除opache缓存
	$cachepath = globalStatic::$root_directory.'dataCache/Cache/';
	chmod($cachepath, 0777);
	$folder = @opendir($cachepath);
	if ($folder == false) return;
	$count = 0;
	$isfile = array('.'=>'1','..'=>'1','index.html'=>'1','index.htm'=>'1');
	while(false !== ($file = readdir($folder))){
		if(isset($isfile[$file])) continue;//不可删除
		if(is_file($cachepath.$file)){
			if(substr($file,0,9) != 'datacache') continue;
			chmod($cachepath.$file, 0777);
			if (@unlink($cachepath.$file)) ++$count;
		}
	}
	closedir($folder);
	clearDataCacheFiles();
	return $count;
}

function clearAllCaCheFiles()
{
   
   
    ClearAllOpacheFile();
    clearCacheFiles();//删除数据缓存
	clearMinifyFiles();//删除JS、CSS缓存
	clearSmartyFiles();//删除tpl页面缓存
	clearDefaultFile();//
	clearAttachmentPdf();//删除附件生成的PDF文件
    unsetCacheDirectory('picklist');
    unsetCacheDirectory('productfields');
    unsetCacheDirectory('fields');
    unsetCacheDirectory('profile');
 
    
    @unlink('include/language/zh.php');
    @unlink('include/language/en.php');
    @unlink('include/language/zh.js');
    @unlink('include/language/en.js');
    if(file_exists("autoremind.txt"))
    {
        @unlink("autoremind.txt");
    }
     crm_load_class_file('create_parenttab_data_file','include/utils');
    create_parenttab_data_file();
    create_tab_language();
    create_parent_language();
    
    @unlink('user_privileges/logo.php');
    global $current_user;
    setFixedLable($current_user);//重新生成语言包
    setJsPopLabel($current_user);
    updateWeiXinVersion(null);//更新微信API端版本号缓存 editor:gyq_31 date:20170918
}
/**
 * 删除缓存文件，遍历dataCache缓存文件夹，
 * 删除自定义缓存文件夹下的缓存
 * @author Tujt 2015-03-04
 */
function clearDataCacheFiles() {
    $cachepath = globalStatic::$root_directory.'dataCache/';
	chmod($cachepath, 0777);
	$folder = @opendir($cachepath);
	if (false == $folder) return;$count = 0;
	$isfile = array('.'=>'1','..'=>'1','index.html'=>'1','index.htm'=>'1');
	$isdir = array('Cache'=>'1','cron'=>'1','Memory'=>'1','Minify'=>'1');
	while(false !== ($file = readdir($folder))){
		if(isset($isfile[$file])) continue;//不可删除
		if(!is_dir($cachepath.$file)) continue;//非文件夹，不删除
		if(isset($isdir[$file])) continue;//一些文件夹有专门的删除方法
		$opener = @opendir($cachepath.$file);
		if (false == $opener) continue;
		while(false !== ($f = readdir($opener))){
			if(isset($isfile[$f])) continue;//不可删除
			if(is_file($cachepath.$file.'/'.$f)){
				if('datacache' != substr($f,0,9)) continue;
				chmod($cachepath.$file.'/'.$f, 0777);
				if (@unlink($cachepath.$file.'/'.$f)) ++$count;
			}
		}
		closedir($opener);
	}
	closedir($folder);
	return $count;
}
/**
 * 删除JS、CSS缓存
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-28
 */
function clearMinifyFiles(){
	$cachepath = globalStatic::$root_directory.'dataCache/Minify/';
	chmod($cachepath, 0777);
	$folder = @opendir($cachepath);
	if ($folder == false) return;
	$count = 0;
	$isfile = array('.'=>'1','..'=>'1','index.html'=>'1','index.htm'=>'1');
	while(false !== ($file = readdir($folder))){
		if(isset($isfile[$file])) continue;//不可删除
		if(is_file($cachepath.$file)){
			if(substr($file,0,7) != 'minify_') continue;
			chmod($cachepath.$file, 0777);
			if (@unlink($cachepath.$file)) ++$count;
		}
	}
	closedir($folder);
	return $count;
}
/**
 * 删除Tpl缓存
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-28
 */
function clearSmartyFiles(){
	$cachepath = globalStatic::$root_directory.'Smarty/templates_c/';
	chmod($cachepath, 0777);
	$folder = @opendir($cachepath);
	if ($folder == false) return;
	$count = 0;
	$isfile = array('.'=>'1','..'=>'1','index.html'=>'1','index.htm'=>'1');
	while(false !== ($file = readdir($folder))){
		if(isset($isfile[$file])) continue;//不可删除
		if(is_file($cachepath.$file)){
			$strlen = strlen($file);
			if(substr($file,($strlen-7),$strlen) != 'tpl.php') continue;
			chmod($cachepath.$file, 0777);
			if (@unlink($cachepath.$file)) ++$count;
		}
	}
	closedir($folder);
	return $count;
}
/**
 * 删除附件word、xls对应生成的PDF文件
 * @author Chj 2015-8-27
 */
function clearAttachmentPdf(){
	$cachepath = globalStatic::$root_directory.'dataCache/AttachmentPdf/';
	chmod($cachepath, 0777);
	$folder = @opendir($cachepath);
	if ($folder == false) return;
	$count = 0;
	while(false !== ($file = readdir($folder))){
		if(is_file($cachepath.$file)){
			chmod($cachepath.$file, 0777);
			if (@unlink($cachepath.$file)) ++$count;
		}
	}
	closedir($folder);
	return $count;
}
/**
 * 删除某一个缓存文件
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-28
 */
function unsetCache($key) {
     global $global_crmredisobj;
     ClearAllOpacheFile();//清除opache缓存
    $global_crmredisobj=CRMRedis::getInstance();
    
    if($global_crmredisobj!='error')
    {
        
         
            return $global_crmredisobj->del($key);
        
    }
    $cachepath = globalStatic::$root_directory.'dataCache/Cache/';
	$key_hash = md5('firstldcrm'.$key.'lastldcrm');
	$cache_filename = $cachepath . 'datacache_' . $key_hash . '.php';
	if(file_exists($cache_filename)){
		chmod($cache_filename, 0777);
        if(function_exists("opcache_reset"))
        {
             opcache_invalidate($cache_filename,true);
        }
		$result = @unlink($cache_filename);
		return $result;
	}
}

function clearAllCache()
{
   
     create_tab_language();
 	 create_parent_language();
    updateWeiXinVersion(null);//更新微信API端版本号缓存 editor:gyq_31 date:20170918
	clearCacheFiles();
	clearMinifyFiles();
	clearSmartyFiles();
	clearDefaultFile();
    unsetCacheDirectory('productfields');
    unsetCacheDirectory('fields');
    unsetCacheDirectory('profile');
	@unlink('include/language/zh.php');
    @unlink('include/language/en.php');
}
function deleteUserPrivileges()
{
     global $current_user;
    $cachepath = 'user_privileges/';
	chmod($cachepath, 0777);
	$folder = @opendir($cachepath);
	if ($folder == false) return;
	$count = 0;
   $strlen=strlen('user_privileges_');
   $count=0;
	while(false !== ($file = readdir($folder))){
		if(isset($isfile[$file])) continue;//不可删除
    
		if(is_file($cachepath.$file)){
		  
			if(strtolower(substr($file,0,$strlen)) != 'user_privileges_') continue;
            $digit=substr($file,$strlen,stripos($file,'.php')-$strlen);
            if($digit==$current_user->id) continue;
			chmod($cachepath.$file, 0777);
			if (@unlink($cachepath.$file)) ++$count;
		}
	}
	closedir($folder);
    
}
/**
 * edit:can
 * reason:删除指定文件夹缓存
 * */
function unsetCacheDirectory($directory){
    
    global $global_crmredisobj;
    $global_crmredisobj=CRMRedis::getInstance();
    if($global_crmredisobj!='error')
    {
        $global_crmredisobj->flushCacheFile();
  
        
        return ;
    }
    
    $cachepath = globalStatic::$root_directory.'dataCache/'.$directory.'/';
   
	chmod($cachepath, 0777);
	$folder = @opendir($cachepath);
	if ($folder == false) return;
	$count = 0;
	$isfile = array('.'=>'1','..'=>'1','index.html'=>'1','index.htm'=>'1');
   
	while(false !== ($file = readdir($folder))){
	  
		if(isset($isfile[$file])) continue;//不可删除
        
		if(is_file($cachepath.$file)){
			if(substr($file,0,9) != 'datacache') continue;
			chmod($cachepath.$file, 0777);
            if(function_exists("opcache_reset"))
            {
                 opcache_invalidate($cachepath.$file,true);
            }
			if (unlink($cachepath.$file)) ++$count;
            
		}
	}
    
	closedir($folder);
	return $count;
}
/**
 * 删除指定文件夹下指定缓存
 * @param String $dir 缓存文件夹
 * @param String $key 缓存键值
 * @author Tujt 2015-06-15
 */
function unsetCacheDirOne($dir,$key) {
    //editor:gyq_20190522 reason:未清除redis缓存  2019/5/22 15:40
    //0036083: （珞落计划企业微信登录）移动端模块列表定制界面：设置字段名称是否启用或是否显示字段名称时，
    //企业微信端单据列表界面显示状态没有生效（联系人模块测试）（邱：我在本地测试，是否启用有效，是否显示字段名称无效）
    global $global_crmredisobj;
    $global_crmredisobj=CRMRedis::getInstance();
    if($global_crmredisobj!='error')
    {
        $global_crmredisobj->del($key);
    }
    $cachepath = globalStatic::$root_directory.'./dataCache/'.$dir.'/';
	$key_hash = md5('firstldcrm'.$key.'lastldcrm');
	$cache_filename = $cachepath . 'datacache_' . $key_hash . '.php';
	if(file_exists($cache_filename)){
		chmod($cache_filename, 0777);
		$result = @unlink($cache_filename);
		return $result;
	}
}
/**
 * 精确删除某个持久缓存的方法
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-28
 */
function unsetMemoryCache($key) {
    $cachepath = './dataCache/Memory/';
	$key_hash = md5('memoryfirstldcrm'.$key.'memorylastldcrm');
	$cache_filename = $cachepath . 'memorycache_' . $key_hash . '.php';
	if(file_exists($cache_filename)){
		chmod($cache_filename, 0777);
		$result = @unlink($cache_filename);
		return $result;
	}
}

/**
 * 删除DataCache目录下除了index的其他文件
 * @author Tujt 2014-08-05
 */
function clearDefaultFile() {
	$cachepath = './dataCache/';
	chmod($cachepath, 0777);
	$folder = @opendir($cachepath);
	if ($folder == false) return;
	$count = 0;
	$isfile = array('.'=>'1','..'=>'1','index.html'=>'1','index.htm'=>'1');
	while(false !== ($file = readdir($folder))){
		if(isset($isfile[$file])) continue;//不可删除
		if(is_file($cachepath.$file)){
			chmod($cachepath.$file, 0777);
			if (@unlink($cachepath.$file)) ++$count;
		}
	}
	closedir($folder);
	return $count;
}
/**
 * edit:can
 * 系统参数
 * */
function getSys_deploy($key,$is_ret='no'){
	static $cache_deployarr;
	if($is_ret=='no'&&!empty($cache_deployarr) && isset($cache_deployarr[$key])) 
    {
        if($key==72)
        {
          
        
            //首要联系人是否开启
            if(!vtlib_isModuleActive('Contacts'))
            {
                //33773: 系统设置>系统参数设置>设置客户明细界面是否显示首要联系人这个参数为是>关闭联系人模块>新增客户：显示出来了联系人姓名、联系人手机字段。（点击展开更多栏目这两个字段就不见了。）
                $cache_deployarr[72]['deploy_value']=1;
                
            }
        }
        return $cache_deployarr[$key];
    }
    
	$cache_deployarr = Cache('systems_deploy');
	if(!$cache_deployarr || !isset($cache_deployarr[$key])){
		 $adb=PearDatabase::getInstance();
		$cache_deployarr = array();
		$sql = 'SELECT deploy_value,deploy_type,setype,inputvalue FROM ld_systems_deploy ORDER BY id;';
		$result = $adb->pquery($sql,array());
		$rows = $adb->num_rows($result);
		for($i=0;$i<$rows;$i++){
			$deploy_value = $adb->query_result($result,$i,'deploy_value');
			$deploy_type = $adb->query_result($result,$i,'deploy_type');
			$setype = $adb->query_result($result,$i,'setype');
			$inputvalue = $adb->query_result($result,$i,'inputvalue');
			$cache_deployarr[$deploy_type] = array('deploy_value'=>$deploy_value,'setype'=>$setype,'deploy_type'=>$deploy_type,'inputvalue'=>$inputvalue);
		}
		Cache('systems_deploy',$cache_deployarr);
	}
    if($key==72)
    {
      
        //首要联系人是否开启
        if(!vtlib_isModuleActive('Contacts'))
        {
            //33773: 系统设置>系统参数设置>设置客户明细界面是否显示首要联系人这个参数为是>关闭联系人模块>新增客户：显示出来了联系人姓名、联系人手机字段。（点击展开更多栏目这两个字段就不见了。）
            $cache_deployarr[72]['deploy_value']=1;
            
        }
    }
	if(isset($cache_deployarr[$key]))
		return $cache_deployarr[$key];
	return '';
}
/**
 *
 * 系统参数(审批单据)
 * */
function getSys_Approvedeploy($key){
	static $cache_deployarr;
	if(!empty($cache_deployarr) && isset($cache_deployarr[$key])) return $cache_deployarr[$key];
	$cache_deployarr = Cache('systems_deploy_approve');
	if(!$cache_deployarr || !isset($cache_deployarr[$key])){
		global $adb;
		$cache_deployarr = array();
		$sql = 'SELECT deploy_value,deploy_type,setype FROM ld_systems_deploy  where (setype  is not null  and setype!=\'\');';
		$result = $adb->pquery($sql,array());
		$rows = $adb->num_rows($result);
		for($i=0;$i<$rows;$i++){
			$deploy_value = $adb->query_result($result,$i,'deploy_value');
			$deploy_type = $adb->query_result($result,$i,'deploy_type');
			$setype = $adb->query_result($result,$i,'setype');
			$cache_deployarr[$setype] = array('deploy_value'=>$deploy_value,'setype'=>$setype,'deploy_type'=>$deploy_type);
		}
		Cache('systems_deploy_approve',$cache_deployarr);
	}
	if(isset($cache_deployarr[$key]))
		return $cache_deployarr[$key];
	return '';
}
/**
 * 获取设置公海目标达成条件
 * 
 * */
function  getAccount_Condition_set()
{
    static $cache_account_condition_set;
	if(!empty($cache_account_condition_set) && isset($cache_account_condition_set))
		return $cache_account_condition_set;
    $cache_account_condition_set = Cache('Account_Condition_set');
   	if(!empty($cache_account_condition_set) && isset($cache_account_condition_set))
		return $cache_account_condition_set;
    global $adb;
    $sql="select * from ld_account_set_condition  order by sequence ";
    $result=$adb->pquery($sql,array());
    for($i=0;$i<$adb->num_rows($result);$i++)
    {
        $day=$adb->query_result($result,$i,'day');
        $isloop=$adb->query_result($result,$i,'isloop');
        $modulename=$adb->query_result($result,$i,'modulename');
        $columnname=$adb->query_result($result,$i,'columnname');
        $arr[]=array('day'=>$day,'isloop'=>$isloop,'modulename'=>$modulename,'columnname'=>$columnname);
    }
    Cache('Account_Condition_set',$arr);
    return $arr;
}
//获取公海客户达成目标条件天数的最大值
function getMaxDay_account_set_condition()
{
    $accountsetconditioninfo=getAccount_Condition_set();
       $days=0;
       foreach($accountsetconditioninfo as $index=>$conditioninfo)
       {
             $tmpday=$conditioninfo['day'];
             if(empty($tmpday))
             {
                continue;
             }
             $arrdays[]=$tmpday;
             
       }
       sort($arrdays);
       $days=$arrdays[sizeof($arrdays)-1];//获取公海客户达成目标条件天数的最大值
       return $days;
}

//获取公海客户达成目标条件天数的最小值
function getMinDay_account_set_condition()
{
    $accountsetconditioninfo=getAccount_Condition_set();
       $days=0;
       foreach($accountsetconditioninfo as $index=>$conditioninfo)
       {
             $tmpday=$conditioninfo['day'];
             if(empty($tmpday))
             {
                continue;
             }
             $arrdays[]=$tmpday;
             
       }
       sort($arrdays);
       $days=$arrdays[0];//获取公海客户达成目标条件天数的最小值
       return $days;
}

function getLeads_set_ProtectedDays($allocatedate,$accountid)
{       global $adb;
		$pool_id = 0;	//公海池id
        
		if(!empty($accountid)){
			$query = "select pool_id from ld_leads where deleted = 0 and leadsid = ?";
			$result = $adb->pquery($query,array($accountid));
			$pool_id = $adb->query_result($result,0,0);
            
		}
         $ruleinfo= getLeads_set_rule("complete",$pool_id);
         $maxdays=0;
         $mindays=9900000000;
         $rows=sizeof($ruleinfo);
        
         if($ruleinfo[0]['condition']=='or')
        {
             for($i=0;$i<$rows;$i++)
            {
                //保护结束日期获取最大的天数
                $days=$ruleinfo[$i]['days'];
               
                    if($days>$maxdays)
                    {
                        $maxdays=$days;
                    }  
            }
            return $maxdays;
        }
        else 
        {
            for($i=0;$i<$rows;$i++)
            {
                //保护结束日期获取最小的天数
                $days=$ruleinfo[$i]['days'];
                $tabname=$ruleinfo[$i]['tabname'];
                $otherwhere=$ruleinfo[$i]['otherwhere'];
                $columnname=$ruleinfo[$i]['columnname'];
                if(empty($allocatedate))
                {
                    return $ruleinfo[0]['days'];//如果没有满足条件的数据则获取第一个最小的天数，例如公海未分配转变公海已分配时
                }
                else
                {
                    
                    $tmpfocus=CRMEntity::getInstance($tabname);
                    $sql='select leadsid from '.$tmpfocus->table_name.' where deleted=0 and  leadsid=? ';
                     if(!empty($otherwhere))
                     {
                        $sql.=$otherwhere;
                     }
                     $sql.=" and date_format( ".$tmpfocus->table_name.".".$columnname.",'%Y-%m-%d') between '$allocatedate' and date_add('$allocatedate',interval $days day) ";
                      $sql=htmlspecialchars_decode($sql);
                      
                     $result=$adb->pquery($sql,array($accountid));
                     if($adb->num_rows($result)<=0)
                     {
                     
                        return $days;
                     }
                }
            }
            return $ruleinfo[0]['days'];//如果没有满足条件的数据则获取第一个最小的天数，例如公海未分配转变公海已分配时
           
        }
}

function getAccount_set_ProtectedDays($allocatedate,$accountid)
{       global $adb;
		$pool_id = 0;	//公海池id
        
		if(!empty($accountid)){
			$query = "select pool_id from ld_account where deleted = 0 and accountid = ?";
			$result = $adb->pquery($query,array($accountid));
			$pool_id = $adb->query_result($result,0,0);
            
		}
         $ruleinfo= getAccount_set_rule("complete",$pool_id);
         $maxdays=0;
         $mindays=9900000000;
         $rows=sizeof($ruleinfo);
        
         if($ruleinfo[0]['condition']=='or')
        {
             for($i=0;$i<$rows;$i++)
            {
                //保护结束日期获取最大的天数
                $days=$ruleinfo[$i]['days'];
               
                    if($days>$maxdays)
                    {
                        $maxdays=$days;
                    }  
            }
            return $maxdays;
        }
        else 
        {
            for($i=0;$i<$rows;$i++)
            {
                //保护结束日期获取最小的天数
                $days=$ruleinfo[$i]['days'];
                $tabname=$ruleinfo[$i]['tabname'];
                $otherwhere=$ruleinfo[$i]['otherwhere'];
                $columnname=$ruleinfo[$i]['columnname'];
                if(empty($allocatedate))
                {
                    return $ruleinfo[0]['days'];//如果没有满足条件的数据则获取第一个最小的天数，例如公海未分配转变公海已分配时
                }
                else
                {
                    
                    $tmpfocus=CRMEntity::getInstance($tabname);
                    $sql='select accountid from '.$tmpfocus->table_name.' where deleted=0 and  accountid=? ';
                     if(!empty($otherwhere))
                     {
                        $sql.=$otherwhere;
                     }
                     $sql.=" and date_format( ".$tmpfocus->table_name.".".$columnname.",'%Y-%m-%d') between '$allocatedate' and date_add('$allocatedate',interval $days day) ";
                      $sql=htmlspecialchars_decode($sql);
                      
                     $result=$adb->pquery($sql,array($accountid));
                     if($adb->num_rows($result)<=0)
                     {
                     
                        return $days;
                     }
                }
            }
            return $ruleinfo[0]['days'];//如果没有满足条件的数据则获取第一个最小的天数，例如公海未分配转变公海已分配时
           
        }
}


 function getLeads_set_rule($type,$pool_id)
{
    global $adb;
    static $ruleinfos;
    if(!empty($ruleinfos[$type]))
    {
        return $ruleinfos[$type];
    }
    //edit:can 2020-12-28 43751: （61mis.com/kfbcrm）客户管理-客户-旧公海；公海参数配置中，只勾选了“ 单次回收规则自分配或领用之日起3天没有创建考勤签到”；领取或分配公海客户后，公海保护日期为空
    $sql="select tabname,ld_leads_set_rule.columnname,ld_field.tablename ,`condition`,ld_leads_set_rule.days
   ,ld_leads_set_rule.otherwhere,ld_leads_set_rule.iscycle from ld_leads_set_rule  
inner join ld_tab on ld_tab.name=ld_leads_set_rule.tabname and (presence in(0,2)  or ld_tab.name='singin')
	INNER JOIN ld_field on ld_field.tabid=ld_tab.tabid and ld_leads_set_rule.columnname=ld_field.columnname
	and (ld_field.presence in(0,2)  or ld_leads_set_rule.tabname='Singin' )
where ld_leads_set_rule.type='$type' and ld_leads_set_rule.pool_id =?
and ld_leads_set_rule.`status`='active'
    order by ld_leads_set_rule.days asc   
 ";
    $result=$adb->pquery($sql,array($pool_id));
 
    $rows=$adb->num_rows($result);
   
    $ruleinfo=array();
     for($i=0;$i<$rows;$i++)
     {
            $tabname=$adb->query_result($result,$i,'tabname');
            $columnname=$adb->query_result($result,$i,'columnname');
            $otherwhere=$adb->query_result($result,$i,'otherwhere');
            $condition=$adb->query_result($result,$i,'condition');
            $days=$adb->query_result($result,$i,'days');
            $iscycle=$adb->query_result($result,$i,'iscycle');
            
            $ruleinfo[]=array("tabname"=>$tabname,'columnname'=>$columnname,
                        'condition'=>$condition,'otherwhere'=>$otherwhere,
                        'days'=>$days,'iscycle'=>$iscycle);
            
            
            
        }
        $ruleinfos[$type]=$ruleinfo;
        
        return $ruleinfo;
}


 function getAccount_set_rule($type,$pool_id)
{
    global $adb;
    static $ruleinfos;
    if(!empty($ruleinfos[$type]))
    {
        return $ruleinfos[$type];
    }
    //edit:can 2020-12-28 43751: （61mis.com/kfbcrm）客户管理-客户-旧公海；公海参数配置中，只勾选了“ 单次回收规则自分配或领用之日起3天没有创建考勤签到”；领取或分配公海客户后，公海保护日期为空
    //47158: （https://51mis.com/hy/hzqe [^]）客户问题（王杰），新建“公海已分配”客户，保护结束日期没有计算：创建时间字段隐藏
    $sql="select tabname,ld_account_set_rule.columnname,ld_field.tablename ,`condition`,ld_account_set_rule.days
   ,ld_account_set_rule.otherwhere,ld_account_set_rule.iscycle from ld_account_set_rule  
inner join ld_tab on ld_tab.name=ld_account_set_rule.tabname and (presence in(0,2)  or ld_tab.name='singin')
	left JOIN ld_field on ld_field.tabid=ld_tab.tabid and ld_account_set_rule.columnname=ld_field.columnname
	and (ld_field.presence in(0,2)  or ld_account_set_rule.tabname='Singin' )
where ld_account_set_rule.type='$type' and ld_account_set_rule.pool_id =?
and ld_account_set_rule.`status`='active'
    order by ld_account_set_rule.days asc   
 ";
    $result=$adb->pquery($sql,array($pool_id));
 
    $rows=$adb->num_rows($result);
   
    $ruleinfo=array();
     for($i=0;$i<$rows;$i++)
     {
            $tabname=$adb->query_result($result,$i,'tabname');
            $columnname=$adb->query_result($result,$i,'columnname');
            $otherwhere=$adb->query_result($result,$i,'otherwhere');
            $condition=$adb->query_result($result,$i,'condition');
            $days=$adb->query_result($result,$i,'days');
            $iscycle=$adb->query_result($result,$i,'iscycle');
            
            $ruleinfo[]=array("tabname"=>$tabname,'columnname'=>$columnname,
                        'condition'=>$condition,'otherwhere'=>$otherwhere,
                        'days'=>$days,'iscycle'=>$iscycle);
            
            
            
        }
        $ruleinfos[$type]=$ruleinfo;
        
        return $ruleinfo;
}

/**
 * edit:can
 * reason:公海客户
 * */
function getAccount_Set($key){
    $tmp_cache_account_setting=getAccount_AllSet($key);
	if(!empty($tmp_cache_account_setting) && isset($tmp_cache_account_setting[$key]))
		return $tmp_cache_account_setting[$key];
	return '';
}

function getAccount_AllSet($key)
{
    	static $cache_account_setting;
    //公海参数-》公海成员设置“全部”->新增一个普通用户->用这个普通用户登录，该普通用户无法看见公海页面
	if(!empty($cache_account_setting) &&$key!='adminaccount')
		return $cache_account_setting;
    $cache_account_setting = Cache('account_set');
   
	if(!$cache_account_setting ||$key=='adminaccount'){
		global $adb;
       
		$sql = 'SELECT IFNULL(status,0) as status,IFNULL(days,0) as days,bills,
					IFNULL(count,0) as count,IFNULL(adminaccount,0) as adminaccount,
					IFNULL(usersaccount,0) as usersaccount,IFNULL(dataprofile,0) as dataprofile,usersaccount_type,
					IFNULL(getprofile,0) as getprofile,IFNULL(wheathershow,0) as wheathershow,
					IFNULL(userid,0) as userid,IFNULL(astricttype,0) as astricttype,IFNULL(allotaccount,0) as allotaccount ,
					case IFNULL(buttontype,"") when "" then "1" when 0 then "1,2,3" else buttontype end buttontype,ifnull(publicaccount,0) as publicaccount,
					ifnull(publicaccount,0) as publicaccount,normalconvertbuttonprofile,objtainaccountcontroldays
					FROM ld_account_set limit 1;';
   
                    //yyx 2015-4-21 在getAccount_Set方法中添加buttontype字段，用于查找出公海参数值
        $result = $adb->pquery($sql,array());
        $rows = $adb->num_rows($result);
        $cache_account_setting=array();
		if($rows > 0){
			$cache_account_setting['status'] = $adb->query_result($result,0,'status');
			$cache_account_setting['days'] = $adb->query_result($result,0,'days');
			$cache_account_setting['bills'] = $adb->query_result($result,0,'bills');
			$cache_account_setting['count'] = $adb->query_result($result,0,'count');
			$cache_account_setting['adminaccount'] = $adb->query_result($result,0,'adminaccount');
			$cache_account_setting['dataprofile'] = $adb->query_result($result,0,'dataprofile');
			$cache_account_setting['getprofile'] = $adb->query_result($result,0,'getprofile');
			// by andy 公海客户改进
			$cache_account_setting['wheathershow'] = $adb->query_result($result,0,'wheathershow');
			$cache_account_setting['userid'] = $adb->query_result($result,0,'userid');
			$cache_account_setting['astricttype'] = $adb->query_result($result,0,'astricttype');//公海客户限制类型、1.用户，2角色
			$cache_account_setting['allotaccount'] = $adb->query_result($result,0,'allotaccount');
            $cache_account_setting['buttontype'] = $adb->query_result($result,0,'buttontype');//yyx 2015-4-21 把sql语句搜索出的公海参数值赋给buttontype
			$cache_account_setting['publicaccount'] = $adb->query_result($result,0,'publicaccount');//快速创建客户默认的客户公海状态
			$cache_account_setting['normalconvertbuttonprofile']=$adb->query_result($result,0,'normalconvertbuttonprofile');
            $cache_account_setting['objtainaccountcontroldays']=$adb->query_result($result,0,'objtainaccountcontroldays');
            $usersaccount_type = $adb->query_result($result,0,'usersaccount_type');
			if($usersaccount_type == 'user'){
				$cache_account_setting['usersaccount'] = $adb->query_result($result,0,'usersaccount');
			}else if($usersaccount_type == 'group'){
				$usersaccount = $adb->query_result($result,0,'usersaccount');
				require_once(globalStatic::$root_directory.'modules/Users/Group.class.php');
				$group = new Group();
				$groupids = explode(',',$usersaccount);
				for($i = 0; $i<sizeOf($groupids); $i++){
					$userid_array[$i] = $group->getGroupOfusers($groupids[$i]);
				}
				foreach($userid_array as $user_info){
					foreach($user_info as $userid => $last_name){
						$userid_arr[$userid] = $userid;
					}
				}
				$cache_account_setting['usersaccount'] = implode(',',$userid_arr);
			}else{
				$userscope = get_user_array(false, "", '');
				$userscopeid = array_keys($userscope);
				$cache_account_setting['usersaccount'] = implode(',',$userscopeid);
			}
		}
    
		Cache('account_set',$cache_account_setting);
      
	}
    return $cache_account_setting;
}
/**
 * edit:andrew
 * reason:获取公海客户用户限制数量
 * */
function getAccount_Set_ByUser(){
	static $cache_account_setting;
	if(!empty($cache_account_setting) && isset($cache_account_setting['count']))
		return $cache_account_setting['count'];
    $cache_account_setting = Cache('account_set');
	if(!$cache_account_setting || !isset($cache_account_setting['count'])){
		global $adb;
		$sql = 'SELECT IFNULL(count,0) as count FROM ld_account_set limit 1;';
        $result = $adb->pquery($sql,array());
        $rows = $adb->num_rows($result);
		if($rows > 0){
			$cache_account_setting['count'] = $adb->query_result($result,0,'count');
		}
		Cache('account_set',$cache_account_setting);
	}
	if(!empty($cache_account_setting) && isset($cache_account_setting['count']))
		return $cache_account_setting['count'];
	return '';
}

/**
 * edit:diony
 * 系统参数
 * */
function getDatainterface($key){
    crm_load_class_file('SystemCache','include/utils');
   return  SystemCache::getDatainterface($key); 
}

/**
 * 获取ld_entityname表的数据
 * @param Integer $tabid 表ID，如果知道模块名，可以通过getTabid 获取表ID
 * @return 对应模块的表名、字段名等信息
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-29
 */
function getEntitynameInfo($tabid) {
	crm_load_class_file('SystemCache','include/utils');
   return  SystemCache::getEntitynameInfo($tabid);
    
}

/**
 * 传入模块名，传回ID值，以ID值取获取表缓存
 * @param String $entityname 模块名
 * @return 返回对应的id值
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-29
 */
function getWsEntityId($entityname) {
    crm_load_class_file('SystemCache','include/utils');
    return  SystemCache::getWsEntityInfo($entityname);
}

/**
 * 通过ID获取ld_ws_entity对应信息
 * @param Integer $entityid ID值
 * @return 返回对应的id值
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-29
 */
function getWsEntityInfo($entityid) {
    crm_load_class_file('SystemCache','include/utils');
    return  SystemCache::getWsEntityInfo($entityid);
}

/**
 * 通过ID获取ld_ws_entity_tables对应的值
 * @param Integer $entityid ID值
 * @return 回传ID对应的表名
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-29
 */
function getWsEntityTables($entityid) {
    crm_load_class_file('SystemCache','include/utils');
    return  SystemCache::getWsEntityTables($entityid);
}

/**
 * 获取ld_ws_fieldtype全表信息
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-29
 */
function getWsFieldTypeInfo() {
     crm_load_class_file('SystemCache','include/utils');
    return  SystemCache::getWsFieldTypeInfo();
}

/**
 * 获取ld_ws_referencetype全表信息
 * @param Integer $fieldtypeid ID
 * @return 回传ID对应的信息（模块有重复）
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-29
 */
function getWsReFerenceTypeInfo($fieldtypeid) {
    crm_load_class_file('SystemCache','include/utils');
    return  SystemCache::getFieldModulerelInfo($fieldtypeid);
}

/**
 * 获取ld_fieldmodulerel全表信息
 * @param Integer $fieldid ID
 * @return 回传ID对应的信息（模块有重复）
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-29
 */
function getFieldModulerelInfo($fieldid) {
   crm_load_class_file('SystemCache','include/utils');
    return  SystemCache::getFieldModulerelInfo($fieldid);
}

/**
 * 获取ld_fieldmodulerel全表信息
 * @param Integer $fieldid ID
 * @return 回传ID对应的信息（模块有重复）
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-29
*/
function getModFldColumnInfo($tabid) {
    crm_load_class_file('SystemCache','include/utils');
    return  SystemCache::getModFldColumnInfo($tabid);
}

/**
 * 获取ld_ws_entity_name全表信息，返回ID对应的数据
 * @param Integer $entity_id ID
 * @return 回传ID对应的信息
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-30
 */
function getWsEntityNameInfo($entity_id) {
    crm_load_class_file('SystemCache','include/utils');
    return  SystemCache::getWsEntityNameInfo();
}

/**
 * 获取主菜单所有数据
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-30
 */
function getParentTabrelInfo() {
    crm_load_class_file('SystemCache','include/utils');
    return  SystemCache::getParentTabrelInfo();
}

/**
 * 获取所有用户ID与名称信息
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-30
 */
function getUserCacheNameInfo() {
    crm_load_class_file('SystemCache','include/utils');
    return  SystemCache::getUserCacheNameInfo();
}

/**
 * 获取ld_ws_entity_referencetype表信息
 * @project PROT58 速度优化：缓存
 * @author Tujt 2014-07-30
 */
function getWsEntityReferencetypeInfo() {
	 crm_load_class_file('SystemCache','include/utils');
    return  SystemCache::getWsEntityReferencetypeInfo();
}

/**
 * 传入仓库id，获取仓库信息
 * @param Integer $warehouseid 仓库id
 * @return Array ID对应仓库信息
 * @author Tujt 2014-08-08
 */
function getWarehouseInfo($warehouseid) {
        crm_load_class_file('SystemCache','include/utils');
       return  SystemCache::getWarehouseInfo($warehouseid);
}

/**
 * fsockopen PHP异步处理方法
 * @param String $url 路径
 * url路径支持 modules.Accounts.setsock 写法
 * @param String $data 传递的值
 * @return 通过sock向服务器发送请求
 * @author Tujt 2014-08-28
 */
function setSockOpen($url,$data = '') {
    global $site_URL;
	if(function_exists('fsockopen')){
		if(!stripos($url,'.php') && stripos($url,'.') > -1){
			$url = strtr($url,'.','/');
			$url .= '.php';
		}
		$urls = explode('/',$site_URL);
		$rootulr = $urls[sizeof($urls)-1];
		$sock_severname = $_SERVER['SERVER_NAME'];
		$server_port = $_SERVER['SERVER_PORT'];
		if(!empty($data)){
			$url .= '?'.$data;
		}
        
		$out = "GET /".$rootulr."/".$url." / HTTP/1.1\r\n";
		$out .= "Host: ".$sock_severname."\r\n";
		$out .= "Connection: Close\r\n\r\n";
        if(strtolower($sock_severname)=='localhost')
         {
                     $sock_severname=gethostbyname($sock_severname);
         }
		$fp = fsockopen($sock_severname,$server_port,$errorno,$errorstr,1);
		if(!$fp&&strtolower($sock_severname)=='localhost'){
			$sock_severname=gethostbyname($sock_severname);
			fclose($fp);
			$fp = fsockopen($sock_severname,$server_port,$errorno,$errorstr,1);
		}
		fputs($fp,$out);
		fclose($fp);
		return 1;
	}else{
		return -1;
	}
}

/**
 * fsockopen PHP异步处理方法，通过sock向服务器发送请求，实现多线程操作
 * @param String $url 路径
 *	  url路径支持 modules.Accounts.setsock 写法
 * @param String $data 传递的值
 * @param Integer $f 可以强制执行某个方法
 * @return 执行异步操作，返回异步操作方法对应的index值
 * @update Tujt 2015-01-14
 */
function f_sockopen($url,$data = '',$f = 0) {
   // global $site_URL;$i = 0;
   global $i;
   $i=0;
	if(function_exists('fsockopen')) $i = 1;//fsockopen 方法链接
	else if(function_exists('pfsockopen')) $i = 2;//pfsockopen 方法链接
	else if(function_exists('stream_socket_client')) $i = 3;//stream_socket_client 方法链接
	$host = $_SERVER['SERVER_NAME'];$port = $_SERVER['SERVER_PORT'];
	 $site_URL=$_SERVER['PHP_SELF'];
      if(!empty($site_URL)){
        $urls = explode('/',$site_URL);
        $rootulr=$urls[0];
        if(empty($rootulr))
        $rootulr = $urls[1];
    }
	if(!stripos($url,'.php') && stripos($url,'.') > -1){
		$url = strtr($url,'.','/');
		$url .= '.php';
	}
    
    $time=10;
	if(!empty($data)) $url .= '?'.$data.'&f_sockopen=1';
	if($f > 0) $i = $f;
	switch($i){
	    case 1://fsockopen
	        $out = "GET /".$rootulr."/".$url." / HTTP/1.1\r\n";
			$out .= "Host:".$host."\r\n";
			$out .= "Connection: Close\r\n\r\n";
			$fp = fsockopen($host,$port,$errorno,$errorstr,$time);
			if(!$fp && strtolower($host) == 'localhost'){
				$host = gethostbyname($host);
				fclose($fp);
				$fp = fsockopen($host,$port,$errorno,$errorstr,10);
			}
			fputs($fp,$out);
			fclose($fp);
	        break;
	    case 2://pfsockopen
	        $out = "GET /".$rootulr."/".$url." / HTTP/1.1\r\n";
			$out .= "Host: ".$severname."\r\n";
			$out .= "Connection: Close\r\n\r\n";
			$fp = pfsockopen($host,$port,$errorno,$errorstr,$time);
			if(!$fp && strtolower($host) == 'localhost'){
				$host = gethostbyname($host);
				fclose($fp);
				$fp = pfsockopen($host,$port,$errorno,$errorstr,10);
			}
			fputs($fp,$out);
			fclose($fp);
	        break;
		case 3://stream_socket_client
	        $out = "GET /".$rootulr."/".$url." / HTTP/1.1\r\n";
			$out .= "Host: ".$host."\r\n";
			$out .= "Connection: Close\r\n\r\n";
			$fp = stream_socket_client($host.':'.$port,$errorno,$errorstr,$time);
			if(!$fp && strtolower($host) == 'localhost'){
				$host = gethostbyname($host);
				fclose($fp);
				$fp = stream_socket_client($host.':'.$port,$errorno,$errorstr,10);
			}
			fputs($fp,$out);
			fclose($fp);
	        break;
		default:
			$i = -1;
			break;

	}
	return $i;
}

/**
 * 获取版本信息
 * @author Tujt 2015-01-07
 */
function getVersionInfo() {
    global $adb;
    static $static_getVersionInfo;
    if(!empty($static_getVersionInfo))
    {
        return $static_getVersionInfo;
    }
//	$cacheKey = 'getVersionInfo';
//	$version = Cache($cacheKey);
//	if(!$version){//18600: 缓存导致首页不显示工作协同，需要重新清理一次缓存
		$version = array();
		$query = 'SELECT id,old_version,current_version,remark,versiontype,trade,account,"getVersionInfo" 
					FROM ld_version WHERE id > 0 LIMIT 1;';
		$result = $adb->pquery($query,array());
		$rows = $adb->num_rows($result);
		if(1 == $rows){
			$version['id'] = $adb->query_result($result,0,'id');
			$version['old_version'] = $adb->query_result($result,0,'old_version');
			$version['current_version'] = $adb->query_result($result,0,'current_version');
			$version['remark'] = $adb->query_result($result,0,'remark');
			$version['versiontype'] = $adb->query_result($result,0,'versiontype');
			$version['trade'] = $adb->query_result($result,0,'trade');
			$version['account'] = $adb->query_result($result,0,'account');
			//Cache($cacheKey,$version);
			//20201214 获取是否授权手写签名
            if(!isset($global_regop)){
                $global_regop=RegOp::getInstance();
            }
            $have_writesign = 'no';
            if($global_regop->gethandleWriteSign_interface() == 1){
                $have_writesign = 'yes';
            }
            $version['have_writesign'] = $have_writesign;
            //20201214 是否授权会话存档
            $have_wechatsession = 'no';
            if($global_regop->getwechatprofile() == 1){
                $have_wechatsession = 'yes';
            }
            $version['have_wechatsession'] = $have_wechatsession;
		}
	$static_getVersionInfo=$version;
	return $version;
}

/**
 * 获取版本信息
 * @author Tujt 2015-01-07
 */
function getVersionTradeInfo() {
    global $adb;
  	$cacheKey = 'getVersionTradeInfo';
	$version = Cache($cacheKey);
    
  	if(!$version){//18600: 缓存导致首页不显示工作协同，需要重新清理一次缓存
		$version = array();
		$query = 'SELECT id,old_version,current_version,remark,versiontype,trade,account ,"getVersionTradeInfo"
					FROM ld_version WHERE id > 0 LIMIT 1;';
		$result = $adb->pquery($query,array());
		$rows = $adb->num_rows($result);
		if(1 == $rows){
			$version['id'] = $adb->query_result($result,0,'id');
			$version['old_version'] = $adb->query_result($result,0,'old_version');
			$version['current_version'] = $adb->query_result($result,0,'current_version');
			$version['remark'] = $adb->query_result($result,0,'remark');
			$version['versiontype'] = $adb->query_result($result,0,'versiontype');
			$version['trade'] = $adb->query_result($result,0,'trade');
			$version['account'] = $adb->query_result($result,0,'account');
			Cache($cacheKey,$version);
		}
	}
	return $version;
}


/**
 * 获取源单的id
 * @author Liver 2016-12-05
 */
 function getProducts_entitytypeid($str,$_sourModuleName,$import_modulename) {
    
    global $adb,$languageType;
		$tabid = array();
		//edit:chj date: 2020/9/21 reason: 0042697：徐燕男客户问题,财务收支明细模块：导入数据，导入模块中分录明细关联了“5条项目立项”源单，导入到系统后只显示“2条”
        //$str=preg_replace("/(\s|\&nbsp\;|　|\xc2\xa0)/","",$str);
        //if($str=='')
        //return 0;
        static $tabentityinfo;
        
        if(array_key_exists($_sourModuleName,$tabentityinfo)&&array_key_exists($str,$tabentityinfo[$_sourModuleName]))
        {
        return $tabentityinfo;
        }
        $sourInformation=getSourModulenameTabid($_sourModuleName,$import_modulename);
        
        $fieldname=$sourInformation['fieldname'];
        $tablename=$sourInformation['tablename'];
        $entityidfield=$sourInformation['entityidfield'];
        $modulename=$sourInformation['name'];
        
        $focus=CRMEntity::getInstance($modulename);
        $maintable=$focus->table_name;
        if($maintable==$tablename)
            $sqlfield='select '.$entityidfield.' from '.$tablename.' where deleted=0 and '.$fieldname.'=? order by '.$entityidfield.' desc limit 0,1';
        else
            $sqlfield=" select $maintable.$entityidfield  from $maintable left join $tablename on $maintable.$entityidfield=$tablename.$entityidfield  where $maintable.deleted=0 and $fieldname=? order by  $maintable.$entityidfield  desc limit 0,1";

        $fieldResult=$adb->pquery($sqlfield,array($str));
        
        if($adb->num_rows($fieldResult)>0){      
            //$tabentityinfo[$_sourModuleName][$str]=$adb->query_result($fieldResult,0,0);
            $sour['id']=$adb->query_result($fieldResult,0,0);
            $sour['fieldname']=$sourInformation['name'];
        }else{
            $sour=0;
        }    
        $tabentityinfo=$sour;
        //Cache($cacheKey,$tabid);
	return $sour;
}
 
//获取源单tabid、源单关键字、源单name
function getSourModulenameTabid($_sourModuleName,$import_modulename){
    global $adb,$languageType;
    
    $sql = 'SELECT
            ld_tab.tabid, 
            ld_tab.`name`, 
            ld_entityname.tablename, 
            ld_entityname.entityidfield,
            ld_entityname.fieldname 
        FROM ld_option_module 
        LEFT JOIN ld_tranlabel ON ld_tranlabel.trantable=? AND ld_tranlabel.Relateid=ld_option_module.option_tabid 
        LEFT JOIN ld_tab ON ld_tab.tabid=ld_option_module.option_tabid 
        LEFT JOIN ld_tab a ON a.tabid=ld_option_module.tabid 
        LEFT JOIN ld_entityname ON ld_entityname.modulename=ld_tab.`name` 
        WHERE a.`name`=? 
            AND ld_option_module.presence=0 
            AND ld_tab.presence=0  
            AND ld_tranlabel.fieldlabel=? 
        LIMIT 1; ';
        
        $result=$adb->pquery($sql,array('ld_tab',$import_modulename,$_sourModuleName));
        $rows=$adb->num_rows($result);
        
        if(1==$rows){
            $str['tabid']=$adb->query_result($result,0,'tabid');
            $str['name']=$adb->query_result($result,0,'name');
            $str['tablename']=$adb->query_result($result,0,'tablename');
            $str['fieldname']=$adb->query_result($result,0,'fieldname');
            $str['entityidfield']=$adb->query_result($result,0,'entityidfield');
        }else{
            $str=0;
        }
        
        return $str;
}
 
 /*
function getProducts_entitytypeid($str,$_modulesName) {
    
    global $adb,$languageType;
		$tabid = array();
        $str=preg_replace("/(\s|\&nbsp\;|　|\xc2\xa0)/","",$str);
        if($str=='')
        return 0;
       static $tabentityinfo;
       if(array_key_exists($_modulesName,$tabentityinfo)&&array_key_exists($str,$tabentityinfo[$_modulesName]))
       {
        return $tabentityinfo[$_modulesName][$str];
       }
		$query = 'SELECT tabid from ld_tranlabel where fieldlabel=? AND trantable=? AND languagetype=? limit 0,1;';
		$result = $adb->pquery($query,array(trim($_modulesName),'ld_tab',$languageType));
		$rows = $adb->num_rows($result);
        

		if(1 == $rows){
            $tabid['tabid'] = $adb->query_result($result,0,'tabid');
            $entiytpe=getEntitynameInfo($tabid['tabid']);
            $entityname=getEntitynameByModulename($entiytpe['modulename']);
            $fieldname=$entityname['fieldname'];
            $tablename=$entityname['tablename'];
            $entityidfield=$entityname['entityidfield'];
            $sqlfield='select '.$entityidfield.' from '.$tablename.' where deleted=0 and '.$fieldname.'=\''.$str.'\' order by '.$entityidfield.' desc limit 0,1';
            $fieldResult=$adb->pquery($sqlfield,array());
      
            if($adb->num_rows($fieldResult)>0){
                $tabentityinfo[$_modulesName][$str]=$adb->query_result($fieldResult,0,0);
                $str=$adb->query_result($fieldResult,0,0);
            }else{
                $str=0;
            }    
			//Cache($cacheKey,$tabid);
		}
	return $str;
}*/


/**
 * 获取源单的模块modules
 * @author Liver 2016-12-05
 */
 function getProducts_entitytypeName($str) {
        global $adb,$current_user;
		$tabid = array();
        if($str=='')
        return '';
        
        static $tabinfo;
        $languageType= getLanguageType($current_user);
        
        if(array_key_exists($str,$tabinfo))
        {
            return $tabinfo[$str];
        }
		$query = 'SELECT tabid from ld_tranlabel where fieldlabel=? AND trantable=? AND languagetype=?';
		$result = $adb->pquery($query,array(trim($str),'ld_tab',$languageType));
		$rows = $adb->num_rows($result);
		if(1 == $rows){
            $tabid['tabid'] = $adb->query_result($result,0,'tabid');
            
            $entiytpe=getEntitynameInfo($tabid['tabid']);
            $tabinfo[$str]= $entiytpe['modulename'];
            
			
		}
	return $entiytpe['modulename'];
}
 
/**
 * 获取源单产品对应的lineitem_id
 * @author Liver 2016-12-05
 */
function getProducts_lineitem_id($crmid,$productsid) {
    global $adb;
		$lineitem_id = array();
        if(empty($crmid)||empty($productsid))
            return 0;
        $settype=getSalesEntityType($crmid);
        $focus=CRMEntity::getInstance($settype);
        $detailtable=$focus->Detail_table;
		$query = " SELECT lineitem_id from $detailtable where id=? AND productid=? order by sequence_no asc  LIMIT 0,1  ";
       
        $result = $adb->pquery($query,array($crmid,$productsid));
		$rows = $adb->num_rows($result);
		if(1 == $rows){
			$lineitem_id['lineitem_id'] = $adb->query_result($result,0,'lineitem_id');
			Cache($cacheKey,$lineitem_id);
		}
	//}
	return $lineitem_id['lineitem_id'];
}

/**
 * in_array方法重写
 * 判断值是否在数据中
 * @author Tujt 2015-01-28
 */
function f_in_array($val,$array) {
    $array = array_flip($array);
    return isset($array[$val]);
}
/**
 * array_search方法重写
 * 通过值获取键值
 * @author Tujt 2015-01-28
 */
function f_array_search($val,$array) {
    $array = array_flip($array);
    return $array[$val];
}
/**
 * array_unique方法重写
 * 删除数组中的重复元素
 * @author Tujt 2015-01-21
 */
function f_array_unique($array) {
    return array_flip(array_flip($array));
}
/**
 * 重写array_key_exists方法，提高效率
 * @author Tujt 2015-03-04
 */
function f_array_key_exists($key,$array) {
	return isset($array[$key])?true:false;
}
/**
 * 把指定元素插入数组指定位置
 * @param Array $array 数组
 * @param Array $arr 插入数组的元素
 * @param Integer $idx 插入数组中的指定下标
 * 默认为插入开头，-1为插入末尾
 * @author Tujt 2015-06-04
 */
function f_array_insert($array,$arr,$idx=0) {
	if(empty($arr)) return $array;
	if(0 == $idx){//插在数组开头
		$array = array_merge($arr,$array);
	}else if(0 > $idx){//从数组末尾附加
		if(-1 == $idx){//附加在数组末尾
			$array = array_merge($array,$arr);
		}else{
			static $s_f_array_insert_count;
			$s_f_array_insert_count = $count = count($array);
			if(($idx = $count + $idx) <= 0){//位置跟数组大小一致，放在开头
				$array = array_merge($arr,$array);
			}else{//从末尾开始算起
				$idx ++;
				$array = f_array_insert($array,$arr,$idx);//$idx必是正整数，不会出现无限递归
			}
		}
	}else{
		static $s_f_array_insert_count;
		$count = ($s_f_array_insert_count > 0)?$s_f_array_insert_count:count($array);
		unset($s_f_array_insert_count);
		if($idx >= $count){//插在数组末尾
			$array = array_merge($array,$arr);
		}else{
			$first = array_splice($array,0,$idx,true);
			$last = array_splice($array,1,$count,true);
			$array = array_merge($first,$arr,$last);
		}
	}
	return $array;
}

/**
 * 获取页面对应信息的值
 * @author Tujt 2015-03-27
 */
function getActionInfo() {
	crm_load_class_file('SystemCache','include/utils');
    return SystemCache::getActionInfo();
}
function getAllActionInfo()
{
    	static $static_getallactioninfo;
	if(!empty($static_getallactioninfo)){
		return $static_getallactioninfo;
	}
	$cachekey = 'allactionmappinginfo';
	$actionarr = Cache($cachekey);
	if(!$actionarr){
		global $adb;
		$actionarr = array();
		$query = 'SELECT actionid,actionname,securitycheck,actionlabel 
					FROM ld_actionmapping ';
		$result = $adb->pquery($query,array());
		$rows = $adb->num_rows($result);
		if($rows > 0){
			for($i=0;$i<$rows;++ $i){
			    $actionid = $adb->query_result($result,$i,'actionid');
				$actionname = $adb->query_result($result,$i,'actionname');
				$securitycheck = $adb->query_result($result,$i,'securitycheck');
				$actionlabel = $adb->query_result($result,$i,'actionlabel');
				$actionarr['action'][$actionid]['actionname'] = $actionname;
				$actionarr['action'][$actionid]['securitycheck'] = $securitycheck;
				$actionarr['action'][$actionid]['actionlabel'] = $actionlabel;
				$actionarr['actionid'][$actionname] = $actionid;
			}
			Cache($cachekey,$actionarr);
		}
	}
	if(!empty($actionarr)) return $static_getallactioninfo = $actionarr;
	return false;
}
/**
 * 与java导入类文件方法名一致，提供缓存类文件导入机制
 * @param string $filename 要导入的方法名
 * @param string $type 文件类型，譬如导入.class文件、.inc文件
 * import('include.utils.EditViewUtils'); -> require './include/utils/EditViewUtils.php';
 * import('data.Logic','class'); -> require './data/Logic.class.php';
 * @return boolean
 * @author Tujt 2015-06-17
 */
function import($filename,$type='') {
	static $_importFiles;
	if (!isset($_importFiles[$filename.$type])){
		if(!stripos($filename,'.php') && stripos($filename,'.') > -1){
			$filename = strtr($filename,'.','/');
			if(!empty($type)) $filename .= '.'.$type;
			$filename .= '.php';
		}
		if (file_exists_case($filename)){
			global $root_directory;
			require $root_directory.$filename;
			$_importFiles[$filename.$type] = 1;
		}
	}
}
/**
 * 区分大小写的文件存在判断
 * @param string $filename 文件地址
 * @return boolean
 */
function file_exists_case($filename) {
    if (is_file(globalStatic::$root_directory.$filename)) {
		if (basename(realpath(globalStatic::$root_directory.$filename)) != basename(globalStatic::$root_directory.$filename))
			return false;
        return true;
    }
    return false;
}

//更新微信API端版本号缓存 editor:gyq_31 date:20170918
function updateWeiXinVersion($rAdb) {
    if(empty($rAdb)){
        $root_directory = globalStatic::$root_directory;
    }else{
        $root_directory = globalStatic::$root_directory.'/';
    }
	$exist_auth_info = file_get_contents($root_directory. 'dataCache/weixin/auth_info.txt');
	$exist_auth_arr = json_decode($exist_auth_info, true);
  
	if(isset($exist_auth_arr['crm'])){
	/*}
    $corp_json = trim(file_get_contents($root_directory.'dataCache/weixin/corpinfo.txt'));
    if(!empty($corp_json)){
        $corp_arr = json_decode($corp_json, true);*/
        if(empty($rAdb)){
            global $adb;
            if(empty($adb)){
                include($root_directory.'include/database/PearDatabase.php');
               include($root_directory.'include/DatabaseUtil.php');
               $adb = PearDatabase::getInstance();
            }
            $query = 'SELECT wx_version
					FROM ld_version WHERE id > 0 LIMIT 1';
            $result = $adb->pquery($query,array());
            $rows = $adb->num_rows($result);
            $wx_version = '';
            if(1 == $rows) {
                $wx_version = $adb->query_result($result, 0, 'wx_version');
            }
            }else{
                //@edit:luyx @date:2021-02-04 @reason: 很早的没有微信，升级出错
                $wx_version = '';
                /*
                $query = 'SELECT wx_version
                            FROM ld_version WHERE id > 0 LIMIT 1';
                $result=$rAdb->query($query);
                $rows=$result->fetch_array();
                $wx_version =$rows['wx_version'];
                */
            }
        $corpid = $exist_auth_arr['crm']['auth_corp_info']['corpid'];

        if(!empty($wx_version)) {
            if(!file_exists($root_directory . 'dataCache/weixin/version.txt'))
            {
                $version_file="";
            }
            else
                $version_file = trim(file_get_contents($root_directory . 'dataCache/weixin/version.txt'));
            if ( $wx_version !=$version_file) {
                include_once($root_directory . 'WeiXinApp/WeiXin_common/StaticConst.php');

                $url = StaticConst::$update_version . '&corpid=' .$corpid . '&version=' . $wx_version;
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                $output = curl_exec($ch);
                curl_close($ch);
                file_put_contents($root_directory . 'dataCache/weixin/version.txt', $wx_version);
                //echo 'Update WeiXin Version:'.$output;
            }
        }
    }else{
        return false;
    }


}

?>